#!/usr/bin/perl -w

IRC::register("XMMS SongDisplay", "0.3", "", "");
IRC::add_command_handler("showmp3", "showmp3");
IRC::print("Loading: XMMS SongDisplay 0.3");

# Set to 1 to add the filename in parentheses to the end of the title.
$add_filename = 0;

# Set to 1 to add the size in bytes to the end of the title.
$add_size = 1;

# Set this to the type of CTCP request used for MP3 broadcasts.
# (Usually "SOUND" or "MP3"...)
$ctcptype = "SOUND";

sub showmp3 {
	my $filename;
	my $filesize;
	my $title;
	my $channel;
	my $command;

	$channel = IRC::get_info(2);
	if (!$channel) {
		IRC::print("Not in a channel!");
		return 1;
	}

	$filename = get_current_file();
	$title = get_title($filename);
	$filesize = -s $filename;

	# Once we have the title, we don't need the path anymore...
	$filename =~ s|.*/||s;
	
	if (!$title) {
		$title = $filename;
	} else {
		if ($add_filename) {
			$title .= " ($filename)";
		}
	}

	$command = "/ctcp $channel $ctcptype \"$filename\" is playing: $title";

	if ($add_size) {
		$command .= " ($filesize bytes)";
	}

	IRC::command ($command);
	
	return 1;
}

sub get_current_file {
	my $filename;
	my $songfile;

        $filename = $ENV{"HOME"} . "/.xmms/current_file";
        open(CURRENT_FILE, $filename);
        $songfile = <CURRENT_FILE>;
        close(CURRENT_FILE);

	return $songfile;
}

sub get_title {
	my $title;
	my $songfile = shift(@_);
	my $buf;
	my $songname;
	my $artist;

	open(MP3, $songfile);
	seek(MP3, -128, 2);

	read(MP3, $buf, 3) || die "Error accessing MP3";

	if ($buf ne "TAG") {
		return undef;
	} else {
		read(MP3, $songname, 30);
		$songname =~ s/\s*$//;
                read(MP3, $artist, 30);
                $artist =~ s/\s*$//;
	
		$title = "$artist - $songname";
	}

	return $title;
}

sub get_size {
	my $filename = shift;
	my $filesize = -s $filename;

	return $filesize;
}
